<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgJshoppingCheckoutJshopping_social_login extends JPlugin {
    
	var $_get_setting;
	
	function __construct($subject, $config){
		parent::__construct($subject, $config);
		$this->get_seting();
	}
	
	function get_seting(){
		require_once(JPATH_SITE.'/components/com_jshopping/bootstrap.php');
		$addon = \JSFactory::getTable("addon", "jshop");
		$addon->loadAlias('jshopping_social_login');
		$this->_get_setting = (object)$addon->getParams();
	}
	
	private function send_request($url){
		$ch = curl_init($url);
		curl_setopt ($ch, CURLOPT_HEADER, 0); 
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_exec ($ch);
		$response = curl_multi_getcontent($ch);
		curl_close ($ch);
		
		return $response;
	}
	
	private function generate_url($nameSocial = 'facebook'){
		$option = (object)$this->_get_setting->$nameSocial;
		$option->redirect_url = isset($this->_get_setting->redirect_url) ? $this->_get_setting->redirect_url : '';
		$option->img_folder = \JURI::root().'media/com_jshopping/addons/jshopping_social_login/';
		$option->url_separator = '&';
		
		$url = new \stdClass();
		$url->nameSocial = $nameSocial;
		$url->show_mod = $option->show_mod;
		switch($nameSocial){
			case 'facebook':
				$option->authentication = 'https://www.facebook.com/dialog/oauth';
				$option->redirect_url = \JURI::root().'index.php?jshopping_social_login=facebook';
				$params = array(
					'client_id'     => $option->client_id,
					'redirect_uri'	=> $option->redirect_url,
					'response_type' => 'code',
					'scope'         => 'email,user_birthday'
				);				
				$url->url = $option->authentication.'?'.http_build_query($params);
				$option->img_url = isset($option->img_url) ? $option->img_url : '';
				$url->image = ($option->img_url) ? $option->img_url : $option->img_folder.'facebook.jpg';
			break;
			
			case 'twitter':
				//$option->redirect_url = \JURI::root().'index.php?jshopping_social_login=twitter';
				$option->redirect_url = \JURI::root().'callback_twitter.php';
				$option->authentication = 'https://api.twitter.com/oauth/request_token';
				$option->authorize = 'https://api.twitter.com/oauth/authorize';
				$oauth_nonce = md5(uniqid(rand(), true));
				$oauth_timestamp = time();
				
				$params = array(
					'oauth_callback=' . urlencode($option->redirect_url) . $option->url_separator,
					'oauth_consumer_key=' . $option->client_key . $option->url_separator,
					'oauth_nonce=' . $oauth_nonce . $option->url_separator,
					'oauth_signature_method=HMAC-SHA1' . $option->url_separator,
					'oauth_timestamp=' . $oauth_timestamp . $option->url_separator,
					'oauth_version=1.0'
				);
				
				$oauth_base_text = implode('', array_map('urlencode', $params));				
				$key = $option->client_secret . $option->url_separator;				
				$oauth_base_text = 'GET' . $option->url_separator . urlencode($option->authentication) . $option->url_separator . $oauth_base_text;				
				$oauth_signature = base64_encode(hash_hmac('sha1', $oauth_base_text, $key, true));

				$params = array(
					$option->url_separator . 'oauth_consumer_key=' . $option->client_key,
					'oauth_nonce=' . $oauth_nonce,
					'oauth_signature=' . urlencode($oauth_signature),
					'oauth_signature_method=HMAC-SHA1',
					'oauth_timestamp=' . $oauth_timestamp,
					'oauth_version=1.0'
				);
				
				$_url = $option->authentication.'?oauth_callback='.urlencode($option->redirect_url).implode('&', $params);				
				$responsestr = self::send_request($_url);				
				parse_str($responsestr, $response);
				
				$oauth_token = isset($response['oauth_token']) ? $response['oauth_token'] : '';
				if (!$oauth_token) {
					\JSHelper::saveToLog("social_login.log", "twitter request_token ".print_r($responsestr, 1));					
				}
				$url->url = $option->authorize. '?oauth_token=' . $oauth_token;
				$option->img_url = isset($option->img_url) ? $option->img_url : '';
				$url->image = ($option->img_url) ? $option->img_url : $option->img_folder.'twitter.jpg';
			break;
			
			case'google':
				$option->authentication = 'https://accounts.google.com/o/oauth2/auth';
				$option->redirect_url = \JURI::root().'index.php';
				$params = array(
					'redirect_uri'  => $option->redirect_url,
					'response_type' => 'code',
					'client_id'     => $option->client_id,
					'scope'         => 'https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile',
					'state' => self::base64UrlEncode('{"jshopping_social_login":"google"}')
				);
				$url->url = $option->authentication.'?'.http_build_query($params);
				$option->img_url = isset($option->img_url) ? $option->img_url : '';
				$url->image = ($option->img_url) ? $option->img_url : $option->img_folder.'google.png';
			break;
		}
		
		return $url;
	}
	
	
	function onBeforeDisplayLoginView(&$view){
		$document = \JFactory::getDocument();
		
		$url_js = \JURI::root()."components/com_jshopping/js/addons/jshopping_social_login/script.js";
		$document->addScript($url_js);
		
		\JPluginHelper::importPlugin('jshoppingcheckout');
        $dispatcher = \JFactory::getApplication();
       
		$social_button = array();
		$mod_social_button = array();
		
		if (isset($this->_get_setting->facebook['status'])){
			$url = self::generate_url('facebook');
			$social_button['facebook'] = $url;
		}
		if (isset($this->_get_setting->twitter['status'])){
			$url = self::generate_url('twitter');
			$social_button['twitter'] = $url;
		}
		if (isset($this->_get_setting->google['status'])){
			$url = self::generate_url('google');
			$social_button['google'] = $url;
		}
		
		$debug = 0;
		if ($debug){
			$url = new stdClass();
			$url->url = \JURI::root().'index.php?jshopping_social_login=debug';
			$url->image = \JURI::root().'components/com_jshopping/images/reload.png';
			$social_button['debug'] = $url;
		}
		
		$dispatcher->triggerEvent('addonSociaLoginCreateIcon', array(&$social_button) );
		
		if (count($social_button)){
			$html = array();
			$html[] = "<div class='jshopping_social_button'>";
			foreach($social_button as $url) {
				if ($url->show_mod) {
					$mod_social_button[] = $url;
				}
				$html[] ="<span>";
				$html[] ='<a href="'.$url->url.'">';
				$html[] ='<img src="'.$url->image.'">';
				$html[] ='</a>';
				$html[] ="</span>";
				$html[] = '&nbsp;';
			}
			$html[] = '</div>';
			$view->tmpl_login_html_3 = isset($view->tmpl_login_html_3) ? $view->tmpl_login_html_3 : '';
			$view->tmpl_login_html_3 .= implode('',$html);
		}
		
		// show button to modul
		$dispatcher->triggerEvent('addonSociaLoginCreateIconMod', array(&$mod_social_button) );
		if (count($mod_social_button)){
			$html = array();
			$html[] = "<div class='jshopping_social_button'>";
			foreach($mod_social_button as $url){
				$html[] ="<span>";
				$html[] ='<a href="'.$url->url.'">';
				$html[] ='<img src="'.$url->image.'">';
				$html[] ='</a>';
				$html[] ="</span>";
				$html[] = '&nbsp;';
			}
			$html[] = '</div>';
			$view->mod_tmpl_login_html_3 = isset($view->mod_tmpl_login_html_3) ? $view->mod_tmpl_login_html_3 : '';
			$view->mod_tmpl_login_html_3 .= implode('',$html);
		}
	}
	
	public static function base64UrlEncode($inputStr) {
		return strtr(base64_encode($inputStr), '+/=', '-_,');
	}
	
	public static function base64UrlDecode($inputStr) {
		return base64_decode(strtr($inputStr, '-_,', '+/='));
	}
}